      subroutine inicon
c
c --- version 2.6 -- cyclic in j
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      real pinit,realat,poflat
      integer lp
      external poflat
      character*24 text
c
      include 'stmt_functions.h'
c
      do 210 j=1,jj
      ja=mod(j-2+jj,jj)+1
      do 210 l=1,isq(j)
      do 210 i=ifq(j,l),ilq(j,l)
      pbot(i  ,j  )=0.
      pbot(i-1,j  )=0.
      pbot(i  ,ja )=0.
      pbot(i-1,ja )=0.
      do 210 k=1,kk
      dp(i  ,j  ,k   )=0.
      dp(i  ,j  ,k+kk)=0.
      dp(i-1,j  ,k   )=0.
      dp(i-1,j  ,k+kk)=0.
      dp(i  ,ja ,k   )=0.
      dp(i  ,ja ,k+kk)=0.
      dp(i-1,ja ,k   )=0.
 210  dp(i-1,ja ,k+kk)=0.
c
c --- initialize  u,ubavg,utotm,uflx,uflux,uflux2/3,uja,ujb  at points
c --- located upstream and downstream (in i direction) of p points.
c --- initialize  depthu,dpu,utotn,pgfx  upstream and downstream of p points
c --- as well as at lateral neighbors of interior u points.
c
      do 156 j=1,jj
      do 156 l=1,isu(j)
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
      do 156 i=ifu(j,l),ilu(j,l)
      pu(i,j,1)=0.
c
      depthu(i,ja)=0.
      utotn (i,ja)=0.
      pgfx  (i,ja)=0.
c
      depthu(i,jb)=0.
      utotn (i,jb)=0.
      pgfx  (i,jb)=0.
c
      do 156 k=1,kk
      dpu(i,ja,k   )=0.
      dpu(i,ja,k+kk)=0.
c
      dpu(i,jb,k   )=0.
      dpu(i,jb,k+kk)=0.
 156  continue
c
      do 158 j=1,jj
      do 158 l=1,isp(j)
      do 158 i=ifp(j,l),ilp(j,l)+1
      depthu(i,j)=0.
      utotn (i,j)=0.
      pgfx  (i,j)=0.
      ubavg(i,j,1)=0.
      ubavg(i,j,2)=0.
      ubavg(i,j,3)=0.
      utotm (i,j)=0.
      uflux (i,j)=0.
      uflux2(i,j)=0.
      uflux3(i,j)=0.
      uja(i,j)=0.
      ujb(i,j)=0.
c
      do 158 k=1,kk
      dpu(i,j,k   )=0.
      dpu(i,j,k+kk)=0.
      uflx(i,j,k)=0.
      u(i,j,k   )=0.
 158  u(i,j,k+kk)=0.
c
c --- initialize  v,vbavg,vtotm,vflx,vflux,vflux2/3,via,vib  at points
c --- located upstream and downstream (in j direction) of p points.
c --- initialize  depthv,dpv,vtotn,pgfy  upstream and downstream of p points
c --- as well as at lateral neighbors of interior v points.
c
      do 166 i=1,ii1
      do 166 l=1,jsv(i)
      ia=mod(i-2+ii,ii)+1
      ib=i+1
      do 166 j=jfv(i,l),jlv(i,l)
      pv(i,j,1)=0.
c
      depthv(ia,j)=0.
      vtotn (ia,j)=0.
      pgfy  (ia,j)=0.
c
      depthv(ib,j)=0.
      vtotn (ib,j)=0.
      pgfy  (ib,j)=0.
c
      do 166 k=1,kk
      dpv(ia,j,k   )=0.
      dpv(ia,j,k+kk)=0.
c
      dpv(ib,j,k   )=0.
      dpv(ib,j,k+kk)=0.
 166  continue
c
      do 168 i=1,ii1
      do 168 l=1,jsp(i)
      do 168 jp=jfp(i,l),jlp(i,l)+1
      j=mod(jp-1+jj,jj)+1
      depthv(i,j)=0.
      vtotn (i,j)=0.
      pgfy  (i,j)=0.
      vbavg(i,j,1)=0.
      vbavg(i,j,2)=0.
      vbavg(i,j,3)=0.
      vtotm (i,j)=0.
      vflux (i,j)=0.
      vflux2(i,j)=0.
      vflux3(i,j)=0.
      via(i,j)=0.
      vib(i,j)=0.
c
      do 168 k=1,kk
      dpv(i,j,k   )=0.
      dpv(i,j,k+kk)=0.
      vflx(i,j,k)=0.
      v(i,j,k   )=0.
 168  v(i,j,k+kk)=0.
c
c --- -------------------------
c --- mass field initialization
c --- -------------------------
c
c --- subtract base value from theta values in coordinate layers
c
      do 16 k=1,kk
 16   theta(k)=theta(k)-thbase
c
      do 10 j=1,jj
      do 10 l=1,isp(j)
      do 10 i=ifp(j,l),ilp(j,l)
      thmix(i,j,1)=theta(1)
      thmix(i,j,2)=theta(1)
      p(i,j,1)=0.
      do 10 k=1,kk
      saln(i,j,k   )=35.0
      temp(i,j,k   )=tofsig(theta(k)+thbase,saln(i,j,k))
      temp(i,j,k+kk)=temp(i,j,k)
      saln(i,j,k+kk)=saln(i,j,k)
 10   tracer(i,j,k)=0.
c
      write (lp,'('' sigma(k):'',3p17f7.2)') (theta(k)+thbase,k=1,kk)
      write (lp,'('' temp (k):'',17f7.2)') (temp(ii/2,jj/2,k),k=1,kk)
      write (lp,'('' saln (k):'',17f7.2)') (saln(ii/2,jj/2,k),k=1,kk)
c
c    coordinates of the center
c
      i0=(ii-1)/2
      j0=150
      choice=1
      if(choice.eq.1) then
c
c     choice=1, then gaussian meddy
c
      do 54 k=1,kk
c
      do 67 j=1,jj
      do 67 l=1,isp(j)
      do 67 i=ifp(j,l),ilp(j,l)
ccc      pinit=6000.*onem
ccc      realat=alat(xpivn-float(i),gridn)
ccc      realat=float(2*i-1-ii1)/float(ii1-1)
ccc     .  +.02*sin(6.2831853*float(j)/float(jj))
ccc     .      *sin(3.1415926*float(i-1)/float(ii1-1))
c
c     maximum interface displacement, cdi  
c     radius of maximum velocity rmax
c
        rmax=25.e5
        ss=(i-i0)**2+(j-j0)**2
        ra=sqrt(ss)*scale
        cdi=400.e5
        dpi=cdi*exp(-1.*ra**2
     .            /(2*rmax**2))
c
c      3 layer case
c
      p(i,j,2)=max(onem,min(depths(i,j)*onem,dp0(1)*onem-dpi/2.))
      p(i,j,3)=max(onem,
     .  min(depths(i,j)*onem,(dp0(1)+dp0(2))*onem+dpi/2.))
      p(i,j,4)=depths(i,j)*onem
c
      dp(i,j,k)=p(i,j,k+1)-p(i,j,k)
 67   dp(i,j,k+kk)=dp(i,j,k)
c
cdiag if (mod(k,3).ne.1) go to 54
cdiag write (text,'(''intf.pressure (m), k='',i3)') k+1
cdiag call prtmsk(ip,p(1,1,k+1),util1,idm,ii1,jj,0.,1./onem,text)
c
 54   continue
c
c
c     v-field
c
      do 3047 i=1,ii1
      do 3047 j=1,jj
      ss=(i-i0)**2+(j-j0-.5)**2
      ra=sqrt(ss)*scale
      dtheta=(theta(2)-theta(1))/2.
      dpi=dtheta*cdi*exp(-1.*ra**2/(2*rmax**2))
      den=corio(i,j)**2-4.*g*dpi/(1000.*rmax**2)
      if (den.le.0.) then 
        print *,corio(i,j)**2
        print *,-4.*g*dpi/(1000.*rmax**2)
        print *,den
        stop 'neg root'
      endif
c
c     gradient balance
c
      vgri=-.5*ra*(-corio(i,j)+sqrt(den))
c
      v(i,j,2)=-1.*abs(vgri)*(i-i0)*scale/ra
c      v(i,j,3)=-1.*abs(vgri)*(i-i0)*scale/ra
 3047      continue
c
c     u-field
c
      do 30 i=1,ii1
      do 30 j=1,jj
      ss=(i-i0-.5)**2+(j-j0)**2
      ra=sqrt(ss)*scale
      dtheta=(theta(2)-theta(1))/2.
      dpi=dtheta*cdi*exp(-1.*ra**2/(2*rmax**2))
      den=corio(i,j)**2-4.*g*dpi/(1000.*rmax**2)
      if (den.le.0.) stop 'neg root'
c
c     gradient balance
c
c
      vgri=-.5*ra*(-corio(i,j)+sqrt(den))
      u(i,j,2)=abs(vgri)*(j-j0)*scale/ra
c      u(i,j,3)=abs(vgri)*(j-j0)*scale/ra
 30      continue
c
      else
c
c     choice=2, then bessel fns based meddy
c
        read(20,*) util1
c
      do 100 i=1,ii
      do 100 j=1,jj
      dp(i,j,1)=onem*(dp0(1)+(dp0(2)-util1(i,j))/2.)
      p(i,j,2)=max(onem,min(depths(i,j)*onem,dp(i,j,1)))
      dp(i,j,2)=onem*util1(i,j)
      p(i,j,3)=max(onem,min(depths(i,j)*onem,dp(i,j,1)+dp(i,j,2)))
      p(i,j,4)=depths(i,j)*onem
      util2(i,j)=onem*util1(i,j)*(theta(3)-theta(2))/2.
 100  continue
c
      do 101 k=1,kk
      do 101 i=1,ii
      do 101 j=1,jj
      dp(i,j,k)=p(i,j,k+1)-p(i,j,k)
      dp(i,j,k+kk)=dp(i,j,k)
 101  continue
c
      do 102 j=2,jj-2
      do 102 i=2,ii-2
      u(i,j,2)=(util2(i,j-1)+util2(i-1,j-1)-
     .  util2(i,j+1)-util2(i-1,j+1))/(scale*4.*corio(i,j))
      v(i,j,2)=(util2(i+1,j)+util2(i+1,j-1)-
     .  util2(i-1,j)-util2(i-1,j-1))
     .  /(scale*2.*(corio(i,j)+corio(i+1,j)))
 102  continue
c
c      print *,(u(i0,j,2),j=1,jj)
c      print *,(v(i,j0,2),i=1,ii)
      endif
c
      do 45 k=1,kk
      do 45 j=1,jj
      do 45 l=1,isp(j)
      do 45 i=ifp(j,l),ilp(j,l)
      ubavg(i,j,1)=ubavg(i,j,1)+dp(i,j,k)*u(i,j,k)
      vbavg(i,j,1)=vbavg(i,j,1)+dp(i,j,k)*v(i,j,k)
      p(i,j,k+1)=p(i,j,k)+dp(i,j,k)
 45   continue
c
      do 46 j=1,jj
      do 46 l=1,isp(j)
      do 46 i=ifp(j,l),ilp(j,l)
      ubavg(i,j,1)=ubavg(i,j,1)/p(i,j,kk+1)
      vbavg(i,j,1)=vbavg(i,j,1)/p(i,j,kk+1)
 46   continue
c
c      
      do 47 k=1,kk
      do 47 j=1,jj
      do 47 l=1,isp(j)
      do 47 i=ifp(j,l),ilp(j,l)
      u(i,j,k)=u(i,j,k)-ubavg(i,j,1)
      v(i,j,k)=v(i,j,k)-vbavg(i,j,1)
      u(i,j,k+kk)=u(i,j,k)
      v(i,j,k+kk)=v(i,j,k)
 47   continue
c
c      print *,(u(i0,j,1)+ubavg(i0,j,1),j=1,jj)
c      print *,(v(i,j0,1)+vbavg(i,j0,1),i=1,ii)
c      print *,(u(i0,j,2)+ubavg(i0,j,1),j=1,jj)
c      print *,(v(i,j0,2)+vbavg(i,j0,1),i=1,ii)
c      print *,(u(i0,j,3)+ubavg(i0,j,1),j=1,jj)
c      print *,(v(i,j0,3)+vbavg(i,j0,1),i=1,ii)
c
c
c      read(11,*),((pbavg(i,j,1),i=1,ii),j=1,jj)
c
      do 50 j=1,jj
      do 50 l=1,isp(j)
      do 50 i=ifp(j,l),ilp(j,l)
      pbavg(i,j,1)=0.
      pbavg(i,j,2)=pbavg(i,j,1)
      pbavg(i,j,3)=pbavg(i,j,1)
      ubavg(i,j,1)=ubavg(i,j,1)
      vbavg(i,j,1)=vbavg(i,j,1)+vbar0
      ubavg(i,j,2)=ubavg(i,j,1)
      ubavg(i,j,3)=ubavg(i,j,1)
      vbavg(i,j,2)=vbavg(i,j,1)
      vbavg(i,j,3)=vbavg(i,j,1)
      pbot(i,j)=p(i,j,kk+1)
c
c --- 2 (equally valid) variations on the montg.pot. initialization theme:
c
ccc      montg(i,j,kk)=0.
ccc      do 52 k=kk-1,2,-1
ccc 52   montg(i,j,k)=montg(i,j,k+1)+p(i,j,k+1)*(theta(k+1)-theta(k))*thref
ccc      montg(i,j,1)=montg(i,j,2)+p(i,j,2)*(theta(2)-thmix(i,j,1))*thref
c
      montg(i,j,1)=0.
      montg(i,j,2)=montg(i,j,1)-p(i,j,2)*(theta(2)-thmix(i,j,1))*thref
      do 52 k=2,kk-1
 52   montg(i,j,k+1)=montg(i,j,k)-p(i,j,k+1)*(theta(k+1)-theta(k))*thref
c
 50   psikk(i,j)=montg(i,j,kk)
c
c
c --- define water depth (bottom pressure) at  u,v,vort  points
c
      do 153 i=1,ii1
      wrap=jfv(i,1).eq.1        !  true if j=1 and j=jj are both water points
c
      do 151 l=1,jsu(i)
      do 151 j=jfu(i,l),jlu(i,l)
      jb=mod(j     ,jj)+1
      depthu(i,j)=uvdep(pbot(i,j),pbot(i-1,j))
      pvtrop(i,j  )=corio(i,j  )*2./(pbot(i,j)+pbot(i-1,j))
      if (j.ne.jj .or. .not.wrap)
     .pvtrop(i,jb )=corio(i,jb )*2./(pbot(i,j)+pbot(i-1,j))
 151  continue
c
      do 152 l=1,jsv(i)
      do 152 j=jfv(i,l),jlv(i,l)
      ja=mod(j-2+jj,jj)+1
      depthv(i,j)=uvdep(pbot(i,j),pbot(i,ja ))
      pvtrop(i  ,j)=corio(i  ,j)*2./(pbot(i,j)+pbot(i,ja ))
 152  pvtrop(i+1,j)=corio(i+1,j)*2./(pbot(i,j)+pbot(i,ja ))
c
      do 153 l=1,jsq(i)
      do 153 j=jfq(i,l),jlq(i,l)
      ja=mod(j-2+jj,jj)+1
 153  pvtrop(i,j)=corio(i,j)*4./(pbot(i,j  )+pbot(i-1,j  )
     .                          +pbot(i,ja )+pbot(i-1,ja ))
c
c --- define initial layer depth at  u,v  points
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1   ),dpv(1,1,1   ))
      call dpudpv(p,depthu,depthv,dpu(1,1,1+kk),dpv(1,1,1+kk))
c
      do 180 k=1,kk
c
c --- define initial layer depth at  u,v  points
c
      do 155 j=1,jj
      ja=mod(j-2+jj,jj)+1
c
      do 154 l=1,isu(j)
      do 154 i=ifu(j,l),ilu(j,l)
      dpu(i,j,k)=max(0.,
     .           min(depthu(i,j),.5*(p(i,j,k+1)+p(i-1,j,k+1)))-
     .           min(depthu(i,j),.5*(p(i,j,k  )+p(i-1,j,k  ))))
 154  dpu(i,j,k+kk)=dpu(i,j,k)
c
      do 155 l=1,isv(j)
      do 155 i=ifv(j,l),ilv(j,l)
      dpv(i,j,k)=max(0.,
     .           min(depthv(i,j),.5*(p(i,j,k+1)+p(i,ja ,k+1)))-
     .           min(depthv(i,j),.5*(p(i,j,k  )+p(i,ja ,k  ))))
 155  dpv(i,j,k+kk)=dpv(i,j,k)
c
 180  continue
c
c      theta(1)=-thbase
c
C
C --- ENERGY DIAGNOSTICS
C
      mm=0
      m=1
      PBAR=0.
      SUMWGT=0.
      SUMPOT=0.
      SUMKIN=0.
      SUMXGR=0.
      SUMSTR=0.
      SUMDIS=0.
      SUMEKT=0.
      DO 53 K=1,KK
      KM=K+MM
      EPOT=0.
      EKIN=0.
      WEIGHT=0.
      DO 51 J=1,JJ
      JA=MOD(J-2+JJ,JJ)+1
      JB=MOD(J     ,JJ)+1
      DO 51 I=1,II1
        IF (K.EQ.1) EPOT=0.
      IF (K.GT.1)
     &EPOT=EPOT+.5*(P(I,J,K)-PBAR)**2*(THETA(K)-THETA(K-1))/G
      EKIN=EKIN+.25*DP(I,J,KM)*((U(I,J,KM)+ubavg(i,j,m))**2
     &  +(U(I+1,J,KM)+ubavg(i+1,j,m))**2
     &  +(V(I,J,KM)+vbavg(i,j,m))**2
     &  +(V(I,JB ,KM)+vbavg(i,jb,m))**2)/G
51    WEIGHT=WEIGHT+DP(I,J,KM)-DP0(K)
      EPOT=EPOT/(II1*JJ)
      EKIN=EKIN/(II1*JJ)
      WEIGHT=WEIGHT/(II1*JJ)
      PRINT 1001,WEIGHT,EPOT,EKIN,EKINT,SUMXGR,SUMSTR,SUMDIS,K
1001  FORMAT (' MASS'1PE10.2'  EPOT'E10.2'  EKIN'E10.2'  EKINT'E10.2
     .'  XCONT'E10.2'  STRESS'E10.2'  DISSIP'E10.2,I4)
      SUMWGT=SUMWGT+WEIGHT
      SUMKIN=SUMKIN+EKIN
      SUMPOT=SUMPOT+EPOT
      SUMXGR=SUMXGR
      SUMSTR=SUMSTR
      SUMDIS=SUMDIS
      SUMEKT=SUMEKT
      DO 53 J=1,JJ
      DO 53 I=1,II1
53    PBAR=PBAR+DP(I,J,KM)/(II1*JJ)
      PRINT 1001,SUMWGT,SUMPOT,SUMKIN,SUMEKT,SUMXGR,SUMSTR,SUMDIS
      return
      end
