      function poflat(theta,xlat)
c
c --- this routine returns pressure as function of density (sigma) and latitude
c
      data thbotm/.004/,thgrad/.0007/,pscale/300.e5/,pbottm/2000.e5/
c
c --- 'pint' defines the initial pressure distribution as a function of
c --- density (theta) and cross-stream coordinate (x)
c
      pint(theta,x)=pscale*sqrt(-2.*alog(min(1.,
     .(thbotm/(1.-exp(-.5*(pbottm/pscale)**2))+thgrad-theta)/
     .(thbotm/(1.-exp(-.5*(pbottm/pscale)**2))+thgrad
     .*tanh(3.*x)/tanh(3.)))))
c
      poflat=pint(theta-.0238,xlat)
      return
      end
